#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include "../../typedfs.h"
#include "hudaqlib.h"


/** This function extracts one uint16 value from the file specified. */
static int sysfs_get_value(const char *FileName)
{
FILE *F;
int RetVal;

  F=fopen(FileName,"rb");
  if(F==NULL) return -1;

  fscanf(F,"%X",&RetVal);
  fclose(F);
return RetVal;
}


static DWORD ScanProc(void)
{
FILE *devices;
DWORD DevTblID;
DWORD DevPos, DevInt;
DWORD Resources[14];
int i;
char ch;

  //devices=fopen("devices","rb");
  devices = fopen("/proc/bus/pci/devices","rb");
  if(devices==NULL) return  0xFFFFFF00 | 4;

    /* loop over devices */
  while(!feof(devices))
    {
    if(fscanf(devices,"%X %X %X", &DevPos, &DevTblID, &DevInt)!=3)
        return  0xFFFFFF00 | 5;

    printf("Device found: DevPos:%X DevTblID:%X DevInt:%X\n", DevPos, DevTblID, DevInt);

    memset(Resources, 0, sizeof(Resources));
    for(i=0; i<14; i++)
      {
      if(fscanf(devices,"%X", &Resources[i])!=1)
        {
	if(i==6 || i==7) break;  //correct
	break; //strange
	}
      }
    do {
       ch = fgetc(devices);
       if(feof(devices)) break;
       } while(ch!='\r' && ch!='\n' && ch!=0);
    }

  fclose(devices);
return(0);
}


static DWORD ScanSys(void)
{
DIR *dir;
FILE *F;
char ch;
struct dirent *entry;
unsigned vendor_id;
unsigned device_id;
char FileName[1024];
const char SysDir[] = "/sys/bus/pci/devices";
unsigned long long start, end, size;
DWORD Resources[14];
int i;

  sprintf(FileName,"%s",SysDir);
  dir = opendir(FileName);
  if(!dir)
    {
    //fprintf(stderr,"Cannot open /sys/bus/pci/devices");
    return  0xFFFFFF00 | 4;
    }

  while((entry = readdir(dir)))
    {
    if(entry->d_name[0]=='.') continue;

    memset(Resources, 0, sizeof(Resources));

    sprintf(FileName,"%s/%s/vendor",SysDir,entry->d_name);
    vendor_id = sysfs_get_value(FileName);
    sprintf(FileName,"%s/%s/device",SysDir,entry->d_name);
    device_id = sysfs_get_value(FileName);

    printf("VendorID:%X DeviceID:%X Position:%s\n", vendor_id, device_id, entry->d_name);
    }

  closedir(dir);
  return 0;
}


int main(void)
{
DWORD res;

  printf("Scanning PCI devices exposed in /proc\n");
  res = ScanProc();
  printf("ScanProc result %X\n", res);

  printf("Scanning PCI devices exposed in /sys\n");
  res = ScanSys();
  printf("ScanSys result %X\n", res);

return 0;
}
